//+------------------------------------------------------------------+
//|                                                            vaMACl|
//|                                              Copyright 2013,  J.B|
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, J.B"
#property version   "1.12"

#include <MovingAverages.mqh>

#property indicator_chart_window 
#property indicator_buffers 3 
#property indicator_plots   1
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  clrGray,clrRoyalBlue,clrOrange
#property indicator_style1  STYLE_SOLID
#property indicator_width1  3
#property indicator_label1  "vaMACl"

input int  vaMA_period=15;
input bool use_double_smooth=1;
input bool bar_exist=1;

double vaMA_buffer[],vaMA_Color_buffer[],EMA[];
//+------------------------------------------------------------------+
//| vaMACl initialization function                                   |
//+------------------------------------------------------------------+  
void OnInit()
  {
   SetIndexBuffer(0,vaMA_buffer,INDICATOR_DATA);
   SetIndexBuffer(1,vaMA_Color_buffer,INDICATOR_DATA);
   SetIndexBuffer(2,EMA,INDICATOR_CALCULATIONS);
  }
//+------------------------------------------------------------------+
//| vaMA iteration function                                          |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,const int prev_calculated,const int begin,const double &price[])
  {
//+------------------------------------------------------------------+
   static int lastBar;
   if(rates_total==lastBar && bar_exist) return(rates_total);                                        //one times draw for one bar
   lastBar=rates_total;
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
   int first;
   if(rates_total<vaMA_period-1)return(0);
   if(prev_calculated==0)first=vaMA_period+begin;                                                    //loop bounds
   else first=prev_calculated-1;
//+------------------------------------------------------------------+

   ExponentialMAOnBuffer(rates_total,prev_calculated,begin,vaMA_period,price,EMA);                   //EMA from price
   VAShift(EMA,vaMA_buffer,first,rates_total,vaMA_period);                                           //VAShift from EMA

   if(use_double_smooth)
   ExponentialMAOnBuffer(rates_total,prev_calculated,begin,vaMA_period/4,vaMA_buffer,vaMA_buffer);   //additional smooth



//+------------------------------------------------------------------+      
   for(int bar=first; bar<rates_total; bar++)
      {
      vaMA_Color_buffer[bar]=0;
      if(vaMA_buffer[bar-1]<vaMA_buffer[bar]) vaMA_Color_buffer[bar]=1;                              //colorize
      if(vaMA_buffer[bar-1]>vaMA_buffer[bar]) vaMA_Color_buffer[bar]=2;
      }       
//+------------------------------------------------------------------+
   return(rates_total);
  }
 
//+------------------------------------------------------------------+
//| Calculate VAShift function                                       |
//+------------------------------------------------------------------+
int VAShift(const double &array[],double &outBuffer[],int begin,int rates_total,int period)
  {
   int period_div=period/4;
   double vel,acc,aaa;
   for(int bar=begin; bar<rates_total; bar++)
     {
      vel = array[bar]-array[bar-period_div];                                         
      acc = array[bar]-2*array[bar-period_div]+(array[bar-period_div*2]+array[bar-period_div/2])/2;
      aaa = array[bar]-3*array[bar-period_div]+3*(array[bar-period_div*2]+array[bar-period_div/2])/2-(array[bar-period_div*3]+array[bar-period_div/3])/2;    
      
      outBuffer[bar]=array[bar]+vel+acc+aaa/3;
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+